<template>
  <div class="customer-insights-client-content">
    <div v-if="customerData && customerData.id === client.attendeeId">
      <div v-if="customerData.videoUserId && memberParticipantsById[customerData.videoUserId]"
           class="customer-insights-row">
        <div class="customer-insights-video-status">
          <SwGsIconMicOff v-if="!memberParticipantsById[customerData.videoUserId].data.audio"
                          class="color-dark-secondary size-xs"/>
          <SwGsIconMicOn v-else class="color-dark-secondary size-xs"/>
          <SwGsIconCameraOff v-if="!memberParticipantsById[customerData.videoUserId].data.video"
                             class="color-dark-secondary size-xs"/>
          <SwGsIconCameraOn v-else class="color-dark-secondary size-xs"/>
        </div>
      </div>

      <div v-if="customerData && customerData.customer" class="customer-insights-row address">
        <div class="customer-insights-label">{{ $t('Address') }}</div>
        {{ customerData.customer.defaultBillingAddress.street }}, {{ customerData.customer.defaultBillingAddress.zipcode }} {{ customerData.customer.defaultBillingAddress.city }} {{ customerData.customer.defaultBillingAddress.country.translated.name }}
      </div>

      <div v-if="customerData && customerData.customer" class="customer-insights-row email">
        <div class="customer-insights-label">{{ $t('Email') }}</div>
        {{ customerData.customer.email }}
      </div>

      <div class="customer-insights-row turnover-last-year">
        <div class="customer-insights-label">{{ $t('Turnover') }} {{ lastYear }}:</div>
        <div class="customer-insights-revenue">
          <div class="revenue-products">{{ lastOrdersItemCount }} {{ $t('product(s)') }}</div>
          <div class="revenue-sum">{{ formatPrice(lastOrdersTotalPrice) }}{{ $t('*') }}</div>
        </div>
      </div>
      <div class="customer-insights-row turnover-current-year">
        <div class="customer-insights-label">{{ $t('Turnover') }} {{ currentYear }}:</div>
        <div class="customer-insights-revenue">
          <div class="revenue-products">{{ currentOrdersItemCount }} {{ $t('product(s)') }}</div>
          <div class="revenue-sum">{{ formatPrice(currentOrdersTotalPrice) }}{{ $t('*') }}</div>
        </div>
      </div>

      <div class="customer-insights-row appointment-actions">
        <div class="customer-insights-label">{{ $t('Actions in this appointment') }}</div>
        <div class="customer-insights-actions">
          <SwGsIconThumbsUpSmall class="color-green-primary size-sm is-action-likes"/>
          <span class="customer-insights-actions-count is-action-likes">{{ customerLikesCount }}</span>
          <SwGsIconThumbsDownSmall class="color-red-primary size-sm is-action-dislikes"/>
          <span class="customer-insights-actions-count is-action-dislikes">{{ customerDislikesCount }}</span>
        </div>
      </div>

      <div class="customer-insights-row permissions">
        <div class="customer-insights-label">
          {{ $t('Cart') }}
          <span v-if="client.guideCartPermissionsGranted"
                class="customer-insights-label-info">{{ $t('(Cart permissions granted)') }}</span>
        </div>
        <template v-if="attendeeData && attendeeData.attendees && attendeeData.attendees[client.attendeeId]">
          {{ attendeeData.attendees[client.attendeeId].productCount }} {{ $t('product(s)') }} {{ formatPrice(attendeeData.attendees[client.attendeeId].cartSum, {symbol: attendeeData.currencySymbol, separator: '.'}) }}{{ $t('*') }}
        </template>
        <template v-else>
          {{ $t('Cart is empty') }}
        </template>
        <SwButton v-if="!client.guideCartPermissionsGranted && allowUserActionsForGuide && !isSelfService && isActive"
                  class="customer-insights-request-permissions is-small"
                  title="$t('Request cart permissons')"
                  @click="requestTokenPermissions(client.attendeeId)">
          {{ $t('Request cart permissons') }}
        </SwButton>
        <SwButton v-if="!isActive"
                  class="customer-insights-request-permissions is-small"
                  title="$t('Act For User')"
                  @click="setCurrentClientForGuide(client.attendeeId);">
          {{ $t('Act For User') }}
        </SwButton>
      </div>
      <div class="customer-insights-row is-price-hint">
        <span class="price-hint">{{ $t('*This is the net price.') }}</span>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
  import { computed } from '@vue/composition-api';
  import { useVideoCall } from "../../../logic/composables/useVideoCall";
  import { useCustomerInsights } from "../../../logic/composables/widgets/useCustomerInsights";
  import { useGsCart } from "../../../logic/composables/useGsCart";
  import { useAppointment } from "../../../logic/composables/useAppointment";
  import { useState } from "../../../logic/composables/useState";
  import SwButton from "@/components/atoms/SwButton.vue";
  import {
    SwGsIconMicOff,
    SwGsIconMicOn,
    SwGsIconCameraOff,
    SwGsIconCameraOn,
    SwGsIconThumbsDownSmall,
    SwGsIconThumbsUpSmall,
  } from "../../icons";
  import { usePriceFilter } from "../../../logic/composables/usePriceFilter";

  export default {
    name: "InsightsClientItem",
    components: {
      SwGsIconThumbsDownSmall,
      SwGsIconThumbsUpSmall,
      SwGsIconMicOff,
      SwGsIconMicOn,
      SwGsIconCameraOff,
      SwGsIconCameraOn,
      SwButton
    },
    props: {
      client: {
        type: [Object, Array, String],
        default: null,
      },
      isActive: {
        type: Boolean,
        default: true,
      },
    },
    setup(props, {}) {
      const {
        customerData,
        attendeeData,
        customerLikesCount,
        customerDislikesCount,
        lastOrdersItemCount,
        currentOrdersItemCount,
        lastOrdersTotalPrice,
        currentOrdersTotalPrice
      } = useCustomerInsights();
      const { formatPrice } = usePriceFilter();

      const { memberParticipantsById } = useVideoCall();
      const { requestTokenPermissions } = useGsCart();
      const { isSelfService } = useAppointment();
      const { stateForAll, setCurrentClientForGuide } = useState();

      const currentYear = new Date().getFullYear();
      const lastYear = new Date().getFullYear() - 1;

      return {
        memberParticipantsById,
        customerData,
        attendeeData,
        customerLikesCount,
        customerDislikesCount,
        requestTokenPermissions,
        currentYear,
        lastYear,
        lastOrdersItemCount,
        setCurrentClientForGuide,
        currentOrdersItemCount,
        lastOrdersTotalPrice,
        currentOrdersTotalPrice,
        allowUserActionsForGuide: computed(() => stateForAll.value?.allowUserActionsForGuide),
        formatPrice,
        isSelfService
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .customer-insights-row {
    margin-bottom: var(--spacer-xs);

    &.is-price-hint {
      display: flex;
      justify-content: flex-end;

      .price-hint {
        font-size: 12px;
        padding: 5px;
      }
    }
  }

  .customer-insights-video-status {
    display: flex;
  }

  .customer-insights-label {
    font-weight: bold;
  }

  .customer-insights-label-info {
    font-weight: normal;
  }

  .customer-insights-actions {
    display: flex;

    .customer-insights-actions-count {
      padding-right: var(--spacer-xs);
    }
  }

  .customer-insights-request-permissions {
    margin-top: var(--spacer-xs);
  }

  .customer-insights-revenue {
    display: flex;

    .revenue-products {
      margin-right: 20px;
    }
  }
</style>
